/****************************************/
/* This is the checkchkrootkit module   */
/* It runs chkrootkit if the user       */
/* supplies the -c option. Check out    */
/* the source chkrootkit dir for more   */
/* info and credits. 			*/
/*					*/
/* chkrootkit was not written by Triode */
/*					*/
/* See lsatmain.c for more details.	*/
/****************************************/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

int checkchkrootkit(filename, verbose, html)
const char *const filename;
int verbose;
int html;
{
    const char * header = NULL;
    const char * shellcode=NULL;
    const char * tempfile =NULL;

    if (verbose >= 0)
    {
    	printf(" Running chkrootkit module...\n");
    }
  
    /* test to see if chkrootkit is in the path */
    /* this could be the case if they installed it */

    tempfile = "/tmp/lsat1.lsat";

    if ((system("which chkrootkit 1>/dev/null 2>/dev/null") < 0))
    {
	/* it should be in the path */
 	shellcode = "chkrootkit 2>/dev/null >>/tmp/lsat1.lsat";
    }
    else
    {
        /* its not in the path, but we */
	/* compiled it during make...  */
        shellcode = "cd chkrootkit-0.41 ;./chkrootkit 2>/dev/null >>/tmp/lsat1.lsat";
    }
   
    header = "Check to see if anything in the list below\nis infected.";

    /* ok, call dostuff to output header/results... */
    if ((dostuff(tempfile, filename, shellcode, header, html)) < 0)
    {
        /* something went wrong */
	perror(" Creation of list failed.");
	return (-1);
    }
    
    if (verbose > 0)
    {
        printf(" Finished in chkrootkit module.\n");
    }

    return(0);
}
